local importPath=string.gsub(getfenv(1)._.Name,"%.MainWindow","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
-- 430,340
mainWindow=Turbine.UI.Lotro.Window();

mainWindow:SetSize(settings.MainWidth,settings.MainHeight);
mainWindow:SetPosition(settings.MainLeft*displayWidth,settings.MainTop*displayHeight);
mainWindow:SetResizable(true);
mainWindow:SetMinimumSize(430,340);

mainWindow.CharCaption=Turbine.UI.Label();
mainWindow.CharCaption:SetParent(mainWindow);
mainWindow.CharCaption:SetFont(settings.Font);
mainWindow.CharCaption:SetPosition(10,45);
mainWindow.CharCaption:SetSize(100,20);

mainWindow.CharList=DropDownList();
mainWindow.CharList:SetParent(mainWindow);
mainWindow.CharList:SetFont(settings.Font);
mainWindow.CharList:SetSize(200,20);
mainWindow.CharList:SetPosition(mainWindow.CharCaption:GetLeft()+mainWindow.CharCaption:GetWidth()+5,mainWindow.CharCaption:GetTop());
mainWindow.CharList:SetZOrder(1);
mainWindow.CharList.SelectedIndexChanged=function()
	selectedCharName=mainWindow.CharList:GetText();
	for k,v in pairs(mainWindow.Panels) do
		if v.LoadCharData ~=nil then
			v.LoadCharData();
		end
	end
end

mainWindow.IconStripBorder=Turbine.UI.Control();
mainWindow.IconStripBorder:SetParent(mainWindow);
mainWindow.IconStripBorder:SetSize(mainWindow:GetWidth()-20,32);
mainWindow.IconStripBorder:SetPosition(10,70);
mainWindow.IconStrip=Turbine.UI.ListBox();
mainWindow.IconStrip:SetParent(mainWindow.IconStripBorder);
mainWindow.IconStrip:SetPosition(0,0);
mainWindow.IconStrip:SetSize(mainWindow:GetWidth()-20,32);
mainWindow.IconStrip:SetOrientation(Turbine.UI.Orientation.Horizontal)
mainWindow.IconScroll=Turbine.UI.Lotro.ScrollBar();
mainWindow.IconScroll:SetParent(mainWindow);
mainWindow.IconScroll:SetSize(mainWindow.IconStrip:GetWidth(),10);
mainWindow.IconScroll:SetPosition(mainWindow.IconStripBorder:GetLeft(),mainWindow.IconStripBorder:GetTop()+mainWindow.IconStripBorder:GetHeight());
mainWindow.IconStrip:SetHorizontalScrollBar(mainWindow.IconScroll);

mainWindow.IconDrag=Turbine.UI.Control();
mainWindow.IconDrag:SetParent(mainWindow.IconStripBorder);
mainWindow.IconDrag:SetMouseVisible(false);
mainWindow.IconDrag:SetVisible(false);
mainWindow.IconDrag:SetSize(32,32);
mainWindow.IconDrag:SetPosition(0,mainWindow.IconStrip:GetTop());
mainWindow.IconDragBorder=Turbine.UI.Control();
mainWindow.IconDragBorder:SetParent(mainWindow.IconDrag);
mainWindow.IconDragBorder:SetMouseVisible(false);
mainWindow.IconDragBorder:SetSize(32,32);
mainWindow.IconDragBorder:SetPosition(0,0);
mainWindow.IconDragBorder:SetBackground(resourcePath.."Drag.tga")
mainWindow.IconDragBorder:SetBlendMode(Turbine.UI.BlendMode.Overlay);
mainWindow.DraggingIcon=false;

hoverMenu=Turbine.UI.ContextMenu();
hoverMenu:GetItems():Add(Turbine.UI.MenuItem(""));

for k,v in ipairs(settings.Panels) do
	local tmpIcon=Turbine.UI.Control();
	tmpIcon.Index=k;
	tmpIcon:SetParent(mainWindow.IconStip);
	if v.Load then
		if v.Show then
			tmpIcon:SetSize(32,32);
		else
			tmpIcon:SetSize(0,32);
		end
		pcall(Turbine.UI.Control.SetBackground,tmpIcon,resourcePath..v.Name..".jpg")
		tmpIcon.MouseEnter=function(sender,args)
			if sender.Index~=mainWindow.IconStrip:GetSelectedIndex() then
				pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..settings.Panels[sender.Index].Name.."_hover.jpg")
			end
		end
		tmpIcon.MouseLeave=function(sender,args)
			if sender.Index~=mainWindow.IconStrip:GetSelectedIndex() then
				pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..settings.Panels[sender.Index].Name..".jpg")
			end
			hoverMenu:Close();
		end
		tmpIcon.MouseHover=function(sender,args)
			local x,y=mainWindow:GetMousePosition()
			x=x+mainWindow:GetLeft();
			y=y+mainWindow:GetTop();
			local text=Resource[language][settings.Panels[sender.Index].StringID]
			if text==nil then
				text=settings.Panels[sender.Index].Name;
			end
			hoverMenu:GetItems():Get(1):SetText(text);
			hoverMenu:ShowMenuAt(x+2,y+15);
		end
		tmpIcon.MouseClick=function(sender,args)
			if mainWindow.IconStrip.OldIndex~=nil then
				local tmpIcon=mainWindow.IconStrip:GetItem(mainWindow.IconStrip.OldIndex);
				pcall(Turbine.UI.Control.SetBackground,tmpIcon,resourcePath..settings.Panels[tmpIcon.Index].Name..".jpg");
				mainWindow.Panels[mainWindow.IconStrip.OldIndex]:SetVisible(false)
			end
			mainWindow.IconStrip.OldIndex=sender.Index;
			pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..settings.Panels[sender.Index].Name.."_pressed.jpg");
			mainWindow.IconStrip:SetSelectedIndex(sender.Index);
			mainWindow.Panels[sender.Index]:SetVisible(true);
			if mainWindow.Panels[sender.Index].Show~=nil then
				mainWindow.Panels[sender.Index].Show();
			end
			mainWindow.CurrentPanel=settings.Panels[sender.Index].Name;
		end
		tmpIcon.MouseDown=function(sender,args)
			-- if Ctrl is pressed, start drag operation
			if mainWindow:IsControlKeyDown() then
				mainWindow.DraggingIcon=true;
				mainWindow.IconDrag:SetVisible(true);
				mainWindow.IconDrag:SetBackground(sender:GetBackground())
				mainWindow.IconDrag:SetLeft(sender:GetLeft()+mainWindow.IconStrip:GetLeft());
				mainWindow.IconMoveX,mainWindow.IconMoveX=mainWindow.IconStrip:GetMousePosition();
			end
		end
		tmpIcon.MouseMove=function(sender,args)
			if mainWindow.DraggingIcon then
				local mouseX,mouseY=mainWindow.IconStrip:GetMousePosition();
				mainWindow.IconDrag:SetLeft(mainWindow.IconDrag:GetLeft()+mouseX-mainWindow.IconMoveX)
				mainWindow.IconMoveX=mouseX;
			end
-- need to force IconStrip to scroll when the dragicon is out of bounds and the strip can scroll
-- same way the Wallet plugin scrolls the display order up/down as needed when dragging a currency
		end
		tmpIcon.MouseUp=function(sender,args)
			if mainWindow.DraggingIcon then
				-- end drag
				mainWindow.DraggingIcon=false;
				mainWindow.IconDrag:SetVisible(false);
				-- now figure out what icon the dragicon is over
				local iconMiddle=mainWindow.IconDrag:GetLeft()+16
				if iconMiddle<0 then iconMiddle=0 end
				if iconMiddle>mainWindow.IconStripBorder:GetWidth() then iconMiddle=mainWindow.IconStripBorder:GetWidth() end
				local newIndex=0;
				for tmpIndex=1,mainWindow.IconStrip:GetItemCount() do
					local tmpItem=mainWindow.IconStrip:GetItem(tmpIndex)
					if tmpItem:GetWidth()>0 and tmpItem:GetLeft()<=iconMiddle and tmpItem:GetLeft()+32>=iconMiddle then
						newIndex=tmpIndex;
						break;
					end
				end
				if newIndex==0 then
					if iconMiddle>16 then
						newIndex=#settings.Panels;
					else
						newIndex=1;
					end
				end
				local oldIndex=sender.Index
				if newIndex~=oldIndex then
					local tmpSetting=settings.Panels[oldIndex];
					local tmpPanel=mainWindow.Panels[oldIndex];
					local tmpButton=mainWindow.IconStrip:GetItem(oldIndex);
					local tmpOption=OptionsPanel.PanelList:GetItem(oldIndex);
					if mainWindow.IconStrip.OldIndex==oldIndex then
						mainWindow.IconStrip.OldIndex=newIndex;
					else
						if mainWindow.IconStrip.OldIndex>oldIndex then mainWindow.IconStrip.OldIndex=mainWindow.IconStrip.OldIndex-1 end
						if mainWindow.IconStrip.OldIndex>=newIndex then mainWindow.IconStrip.OldIndex=mainWindow.IconStrip.OldIndex+1 end
					end
					if newIndex<oldIndex then
						for tmpIndex=oldIndex,newIndex+1,-1 do
							settings.Panels[tmpIndex]=settings.Panels[tmpIndex-1];
							mainWindow.Panels[tmpIndex]=mainWindow.Panels[tmpIndex-1];
							mainWindow.IconStrip:GetItem(tmpIndex-1).Index=tmpIndex;
							OptionsPanel.PanelList:GetItem(tmpIndex-1).Index=tmpIndex;
						end
						settings.Panels[newIndex]=tmpSetting;
						mainWindow.Panels[newIndex]=tmpPanel;
					else
						for tmpIndex=oldIndex,newIndex-1 do
							settings.Panels[tmpIndex]=settings.Panels[tmpIndex+1];
							mainWindow.Panels[tmpIndex]=mainWindow.Panels[tmpIndex+1];
							mainWindow.IconStrip:GetItem(tmpIndex+1).Index=tmpIndex;
							OptionsPanel.PanelList:GetItem(tmpIndex+1).Index=tmpIndex;
						end
						settings.Panels[newIndex]=tmpSetting;
						mainWindow.Panels[newIndex]=tmpPanel;
					end
					tmpButton.Index=newIndex;
					tmpOption.Index=newIndex;
					mainWindow.IconStrip:RemoveItemAt(oldIndex);
					mainWindow.IconStrip:InsertItem(newIndex,tmpButton);
					OptionsPanel.PanelList:RemoveItemAt(oldIndex);
					OptionsPanel.PanelList:InsertItem(newIndex,tmpOption);
					-- force the selected button icon
					local tmpItem=mainWindow.IconStrip:GetItem(mainWindow.IconStrip.OldIndex);
					pcall(Turbine.UI.Control.SetBackground,tmpItem,resourcePath..settings.Panels[tmpItem.Index].Name.."_pressed.jpg");
					mainWindow.IconStrip:SetSelectedIndex(mainWindow.IconStrip.OldIndex);
				end
				-- now reassign row back colors in OptionsPanel
				local rowFlag=false
				for tmpIndex=1,OptionsPanel.PanelList:GetItemCount() do
					tmpRow=OptionsPanel.PanelList:GetItem(tmpIndex)
					if rowFlag then
						tmpRow:SetBackColor(Turbine.UI.Color(.05,.05,.05));
					else
						tmpRow:SetBackColor(Turbine.UI.Color(0,0,0));
					end
					if tmpRow:GetHeight()~=0 then
						rowFlag=not rowFlag;
					end
				end

			end
		end
	else
		tmpIcon:SetSize(0,32);
	end
	mainWindow.IconStrip:AddItem(tmpIcon)
end

mainWindow.Panels={};
mainWindow.PanelBack=Turbine.UI.Control();
mainWindow.PanelBack:SetParent(mainWindow);
mainWindow.PanelBack:SetPosition(10,mainWindow.IconScroll:GetTop()+mainWindow.IconScroll:GetHeight()+10);
mainWindow.PanelBack:SetSize(mainWindow:GetWidth()-20,mainWindow:GetHeight()-mainWindow.PanelBack:GetTop()-45);
mainWindow.InvalidMsg=Turbine.UI.Label();
mainWindow.InvalidMsg:SetParent(mainWindow.PanelBack);
mainWindow.InvalidMsg:SetVisible(false);
mainWindow.InvalidMsg:SetPosition(0,0);
mainWindow.InvalidMsg:SetMultiline(true);
mainWindow.InvalidMsg:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

for k,v in ipairs(settings.Panels) do
	if v.Load then
		local result,error=loadstring("import \""..importPath..v.Name.."\"");
		if result==nil then
			Turbine.Shell.WriteLine("Error:"..tostring(error));
			mainWindow.Panels[k]=Turbine.UI.Control(); -- dummy placeholder
		else
			success,retVal=pcall(result);
			if success then
				result,error=loadstring("mainWindow.Panels["..tostring(k).."]="..v.Name.."Panel");
				if result==nil then
					Turbine.Shell.WriteLine("Error:"..tostring(error));
					mainWindow.Panels[k]=Turbine.UI.Control(); -- dummy placeholder
				else
					success,retVal=pcall(result);
					if not success then
						Turbine.Shell.WriteLine("Error:"..tostring(retVal))
					end
				end
			else
				Turbine.Shell.WriteLine("Error:"..tostring(retVal))
				mainWindow.Panels[k]=Turbine.UI.Control(); -- dummy placeholder
			end
		end
	else
		mainWindow.Panels[k]=Turbine.UI.Control(); -- dummy placeholder
	end
	mainWindow.Panels[k].Name=v.Name;
	mainWindow.Panels[k].Index=k;
end
mainWindow.CurrentPanel=settings.DefaultPanel;
if mainWindow.CurrentPanel=="Most Recent" then
	if settings.MostRecentPanel==nil or panelID[settings.MostRecentPanel]==nil then
		mainWindow.CurrentPanel="First Available"
	else
		mainWindow.CurrentPanel=settings.MostRecentPanel;
	end
end
if mainWindow.CurrentPanel~="First Available" and not (settings.Panels[panelID[mainWindow.CurrentPanel]].Load and settings.Panels[panelID[mainWindow.CurrentPanel]].Show) then
	mainWindow.CurrentPanel="First Available"
end
for k,v in ipairs(mainWindow.Panels) do
	if mainWindow.CurrentPanel=="First Available" and settings.Panels[k].Load and settings.Panels[k].Show then
		mainWindow.CurrentPanel=v.Name;
	end
	v:SetParent(mainWindow.PanelBack);
	if v.Name==mainWindow.CurrentPanel then
		v:SetVisible(true);
		mainWindow.IconStrip.OldIndex=k;
		mainWindow.IconStrip:SetSelectedIndex(k);
		local tmpItem=mainWindow.IconStrip:GetItem(k);
		pcall(Turbine.UI.Control.SetBackground,tmpItem,resourcePath..settings.Panels[tmpItem.Index].Name.."_pressed.jpg");
	else
		v:SetVisible(false);
	end
end
mainWindow.Closed=function()
	if settings.ShowIcon then
		iconWindow:SetVisible(true);
	end
end

mainWindow:SetVisible(not settings.LoadMinimized);

mainWindow.SetLanguage=function()
	mainWindow.CharCaption:SetText(Resource[language][4]..":");
	mainWindow:SetText(Resource[language][2]);
	for k,v in ipairs(mainWindow.Panels) do
		if v.SetLanguage ~= nil then
			v.SetLanguage();
		end
	end
end
mainWindow.SizeChanged=function(sender,args)
	local newWidth=mainWindow:GetWidth();
	local newHeight=mainWindow:GetHeight();
	mainWindow.CharList:SetWidth(newWidth-mainWindow.CharList:GetLeft()-10);
	mainWindow.IconStripBorder:SetWidth(newWidth-20);
	mainWindow.IconStrip:SetWidth(newWidth-20);
	mainWindow.IconScroll:SetWidth(newWidth-20);
	mainWindow.PanelBack:SetSize(mainWindow:GetWidth()-20,mainWindow:GetHeight()-mainWindow.PanelBack:GetTop()-45);
	mainWindow.InvalidMsg:SetSize(mainWindow.PanelBack:GetSize());
	for k,v in ipairs(mainWindow.Panels) do
		if v.SizeChanged~=nil then
			v.SizeChanged(v);
		end
	end
end
mainWindow.SetColors=function()
	mainWindow.CharList:SetBackColor(settings.BackColor);
	mainWindow.CharList:SetCurrentBackColor(settings.BackColor);
	mainWindow.IconStrip:SetBackColor(settings.BackColor);
	mainWindow.CharList:SetBorderColor(settings.TrimColor);
	mainWindow.CharCaption:SetForeColor(settings.ForeColor);
	for k,v in ipairs(mainWindow.Panels) do
		if v.SetColors~=nil then
			v.SetColors();
		end
	end
end

mainWindow:SetLanguage();
mainWindow:SizeChanged();
mainWindow:SetColors();
